# NAME
net &mdash; Networking module

# LIBRARY
MeasurementKit (libmeasurement_kit, -lmeasurement_kit).

# SYNOPSIS
```C++
#include <measurement_kit/net.hpp>
```

# DESCRIPTION

The `net` module contains the following networking functionality:

- [buffer](net/buffer.md): Buffer for incoming/outgoing data
- [connect](net/connect.md): Functions to establish connections
- [error](net/error.md): Network-level errors
- [transport](net/transport.md): Abstract interface for connected sockets
- [utils](net/utils.md): Utility functions

# HISTORY

The `net` module appeared in MeasurementKit 0.1.0.
